#!/usr/bin/env python

# CMake Help Interface
#
# Copyright 2007 Aleix Pol <aleixpol@gmail.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#


import sys
from PyQt4 import QtCore, QtGui

from ui_mainwin import Ui_MainWindow


class CMakeHelp(QtGui.QMainWindow):
	def initializeCombo(self):
		p=QtCore.QProcess()
		p.start("cmake", QtCore.QStringList("--help-command-list"))
		p.waitForFinished()
		out = p.readAllStandardOutput().split("\n")
		first=1
		for a in out:
			if first!=1 and a!="":
				self.ui.commandCombo.addItem(QtCore.QString(a))
			first=0
	
	def currentChanged(self, current):
		param=QtCore.QStringList("--help-command")
		param.append(current)
		p=QtCore.QProcess()
		p.start("cmake", param)
		p.waitForFinished()
		a=QtCore.QString(p.readAllStandardOutput())
		self.ui.output.setText(a)
	
	def about(self):
		QtGui.QMessageBox.warning(None, "About", "CMake Help\n"+"Interface developed by Aleix Pol Gonzalez (C) 2007 under GPLv2 terms\n"+
						"The cmake texts are extracted from the cmake executable in the $PATH.")
	
	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.ui = Ui_MainWindow()
		self.ui.setupUi(self)
		self.initializeCombo()
		
		self.connect(self.ui.commandCombo, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.currentChanged)
		self.connect(self.ui.actionQuit, QtCore.SIGNAL("triggered()"), self.close)
		self.connect(self.ui.actionAbout, QtCore.SIGNAL("triggered()"), self.about)

if __name__ == "__main__":
	app = QtGui.QApplication(sys.argv)
	win = CMakeHelp()
	win.show()
	sys.exit(app.exec_())
